
//
// To jest przykładowy kod z podrozdziału 7.7 "Odzyskiwanie sprawności po wystąpieniu błędu" książki 
// "Programowanie. Teoria i praktyka z wykorzystaniem C++" Bjarne'a Stroustrupa.
//

#include "std_lib_facilities.h"

/*
    Prosty kalkulator

    Historia:

        Poprawiony przez: Bjarne Stroustrup, maj 2007
        Poprawiony przez: Bjarne Stroustrup sierpień 2006
        Poprawiony przez: Bjarne Stroustrup sierpień 2004
        Autor oryginału: Bjarne Stroustrup
            (bs@cs.tamu.edu) wiosna 2004.

    Ten program stanowi implementację kalkulatora podstawowych wyrażeń.
    Dane wejściowe pobiera ze strumienia cin, wyniki wysyła do strumienia cout.

    Gramatyka danych wejściowych:

    Statement:
        Expression
        Print
        Quit

    Print:
        ;

    Quit:
        q 

    Expression:
        Term
        Expression + Term
        Expression - Term
    Term:
        Primary
        Term * Primary
        Term / Primary
        Term % Primary
    Primary:
        Number
        ( Expression )
        - Primary
        + Primary
    Number:
        floating-point-literal


        Dane przychodzą ze strumienia cin przez strumień Token_stream o nazwie ts.
*/

//------------------------------------------------------------------------------

const char number = '8';    // t.kind==number oznacza, że t jest tokenem liczbowym.
const char koniec   = 'q';    // t.kind==koniec oznacza, że t jest tokenem oznaczającym zamknięcie programu.
const char print  = ';';    // t.kind==print oznacza, że t jest tokenem oznaczającym drukowanie.
const string prompt = "> ";
const string result = "= "; // Oznacza, że to co znajduje się dalej jest wynikiem.

//------------------------------------------------------------------------------

class Token {
public:
    char kind;        // Rodzaj tokenu.
    double value;     // Dla liczb: wartość.
    Token(char ch)    // Tworzy token ze znaku.
        :kind(ch), value(0) { }    
    Token(char ch, double val)     // Tworzy token ze znaku i liczby typu double.
        :kind(ch), value(val) { }
};

//------------------------------------------------------------------------------

class Token_stream {
public: 
    Token_stream();   // Tworzy strumień tokenów wczytujący dane ze strumienia cin.
    Token get();      // Pobiera token (funkcja get() została zdefiniowana w innym miejscu).
    void putback(Token t);    // Zwraca token.
private:
    bool full;        // Sprawdza czy w buforze jest token.
    Token buffer;     // Przechowuje tokeny zwrócone przez funkcję putback().
};

//------------------------------------------------------------------------------

// Konstruktor ustawia wartość full w taki sposób, że oznacza pusty bufor:
Token_stream::Token_stream()
:full(false), buffer(0)    // Bufor jest pusty.
{
}

//------------------------------------------------------------------------------

// Funkcja składowa putback() wstawia swój argument z powrotem do bufora Token_stream::
void Token_stream::putback(Token t)
{
    if (full) error("Funkcja putback() wstawia dane do pełnego bufora.");
    buffer = t;       // Kopiuje t do bufora.
    full = true;      // Bufor jest pełny.
}

//------------------------------------------------------------------------------

Token Token_stream::get() // Wczytuje znaki ze strumienia cin i tworzy tokeny.
{
    if (full) {         // Sprawdza czy jest już gotowy token.
        full=false;
        return buffer;
    }  

    char ch;
    cin >> ch;          // Operator >> pomija białe znaki (spacje, znaki nowego wiersza, tabulatory itp.).

    switch (ch) {
    case koniec:
    case print:
    case '(':
    case ')':
    case '+':
    case '-':
    case '*':
    case '/': 
    case '%':
        return Token(ch); // Każdy znak reprezentuje sam siebie.
    case '.':             // Literał zmiennoprzecinkowy może zaczynać się od kropki.
    case '0': case '1': case '2': case '3': case '4':
    case '5': case '6': case '7': case '8': case '9':    // Literał liczbowy.
    {
        cin.putback(ch);// Wstawia cyfrę z powrotem do strumienia wejściowego.
        double val;
        cin >> val;     // Wczytuje liczbę zmiennoprzecinkową.
        return Token(number,val);
    }
    default:
        error("Bad token");
    }
}

//------------------------------------------------------------------------------

Token_stream ts;        // Dostarcza funkcji get() i pushback().

//------------------------------------------------------------------------------

double expression();    // Dzięki tej deklaracji funkcja primary() może wywołać funkcję expression().

//------------------------------------------------------------------------------

// Obsługa liczb i nawiasów.
double primary()
{
    Token t = ts.get();
    switch (t.kind) {
    case '(':           // Obsługa '(' wyrażenie ')'.
        {
            double d = expression();
            t = ts.get();
            if (t.kind != ')') error("')' był oczekiwany");
            return d;
        }
    case number:    
        return t.value;    // Zwraca wartość liczby.
    case '-':
        return - primary();
    case '+':
        return primary();
    default:
        error("Oczekiwano czynnika.");
    }
}

//------------------------------------------------------------------------------

// Obsługa *, / oraz %.
double term()
{
    double left = primary();
    Token t = ts.get(); // Pobiera następny token ze strumienia tokenów.

    while(true) {
        switch (t.kind) {
        case '*':
            left *= primary();
            t = ts.get();
            break;
        case '/':
            {    
                double d = primary();
                if (d == 0) error("Dzielenie przez zero.");
                left /= d; 
                t = ts.get();
                break;
            }
        case '%':
            {    
                int i1 = narrow_cast<int>(left);
                int i2 = narrow_cast<int>(term());
                if (i2 == 0) error("%: Dzielenie przez zero.");
                left = i1%i2; 
                t = ts.get();
                break;
            }
        default: 
            ts.putback(t);        // Wstawia t z powrotem do strumienia tokenów.
            return left;
        }
    }
}

//------------------------------------------------------------------------------

// Obsługa + i -.
double expression()
{
    double left = term();      // Wczytuje i oblicza wartość składnika.
    Token t = ts.get();        // Pobiera następny token ze strumienia tokenów.

    while(true) {    
        switch(t.kind) {
        case '+':
            left += term();    // Oblicza wartość składnika i dodaje.
            t = ts.get();
            break;
        case '-':
            left -= term();    // Oblicza wartość składnika i odejmuje.
            t = ts.get();
            break;
        default: 
            ts.putback(t);     // Wstawia t z powrotem do strumienia tokenów.
            return left;       // Nie ma więcej znaków + i -. Zwraca wynik.
        }
    }
}

//------------------------------------------------------------------------------

void clean_up_mess()           // naiwne rozwiązanie
{ 
    while (true) {             // Pomija znaki aż do napotkania znaku drukowania.
        Token t = ts.get();
        if (t.kind == print) return;
    }
}

//------------------------------------------------------------------------------

void calculate()
{
    while (cin)
      try {
        cout << prompt;
        Token t = ts.get();
        while (t.kind == print) t=ts.get();    // Najpierw ignoruje wszystkie znaki drukowania.
        if (t.kind == koniec) return;          // koniec
        ts.putback(t);
        cout << result << expression() << endl;
    }
    catch (exception& e) {
        cerr << e.what() << endl;        // Drukuje komunikat o błędzie.
        clean_up_mess();
    }
}

//------------------------------------------------------------------------------

int main()
try {
    calculate();
    keep_window_open();    // Rozwiązuje problem zamykania okna konsoli w systemie Windows.
    return 0;
}
catch (runtime_error& e) {
    cerr << e.what() << endl;
    keep_window_open("~~");
    return 1;
}
catch (...) {
    cerr << "Wyjątek \n";
    keep_window_open("~~");
    return 2;
}

//------------------------------------------------------------------------------
